///////////////////////////////////////////////
// 
//  Snipe2d ludum dare 48h compo entry
//
//  Jari Komppa aka Sol 
//  http://iki.fi/sol
// 
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
//
///////////////////////////////////////////////
//
// Houses are taken from a satellite picture of glasgow.
//
// The sources are a mess, as I didn't even try to do anything
// really organized here.. and hey, it's a 48h compo =)
//
#include "snipe2d.h"
extern void fillrect (int x1, int y1, int x2, int y2, int color);
PBUTTONS pbut;

void init_logoscreen()
{
    char path[256];
    printf ("Initializing logo screen\n");

    // Note the lack of error checking.  Bad, bad, bad.
    snprintf (path, 256, "%s/1.png", mediaPath);
    pbut.lv[0] = IMG_Load (path);
    snprintf (path, 256, "%s/2.png", mediaPath);
    pbut.lv[1] = IMG_Load (path);
    snprintf (path, 256, "%s/3.png", mediaPath);
    pbut.lv[2] = IMG_Load (path);
    snprintf (path, 256, "%s/easy.png", mediaPath);
    pbut.easy = IMG_Load (path);
    snprintf (path, 256, "%s/medium.png", mediaPath);
    pbut.med = IMG_Load (path);
    snprintf (path, 256, "%s/hard.png", mediaPath);
    pbut.hard = IMG_Load (path);
    snprintf (path, 256, "%s/audio.png", mediaPath);
    pbut.audio = IMG_Load (path);
    snprintf (path, 256, "%s/fullscreen.png", mediaPath);
    pbut.fullscreen = IMG_Load (path);
    snprintf (path, 256, "%s/newgame.png", mediaPath);
    pbut.newgame = IMG_Load (path);
    snprintf (path, 256, "%s/quit.png", mediaPath);
    pbut.quit = IMG_Load (path);
    snprintf (path, 256, "%s/resumegame.png", mediaPath);
    pbut.resumegame = IMG_Load (path);
}

void logoscreen()
{
    const char *logoscreen_img = "logoscreen.png";
    char path[ strlen(mediaPath) + 1 + strlen(logoscreen_img) + 1 ];
    sprintf(path, "%s/%s", mediaPath, logoscreen_img);
 
    SDL_Surface *logoscreen = IMG_Load(path);
    SDL_BlitSurface(logoscreen, NULL, gScreen, NULL);

    fillrect (390, 4, 570, 35, 0x007f00);
    fillrect (391, 5, 569, 34, 0x003f00);

    SDL_Flip(gScreen);
    init();
    int go = 0;
    int startTick = SDL_GetTicks();
    SDL_ShowCursor(1);
    while (!go)
    {
        SDL_Event event;
        while ( SDL_PollEvent(&event) ) 
        {
            switch (event.type) 
            {
            case SDL_KEYUP:
                if (event.key.keysym.sym == SDLK_ESCAPE)
                    exit(0);
		if (event.key.keysym.sym == SDLK_F12)
		    show_hiscores();
                break;
            case SDL_MOUSEBUTTONUP:
                if ((SDL_GetTicks() - startTick) > 500)
		    {
			go = 1;
			SDL_ShowCursor(0);
		    }
                break;
            case SDL_QUIT:
                exit(0);
            }
        }
    }
    SDL_FreeSurface(logoscreen);
}
